
Ruby - Bug #11736

Float(arg) not consistent with documentation

11/24/2015 08:10 PM - bwheeler96 (Brian Wheeler)

Status: Closed   

Priority: Normal   

Assignee: hsbt (Hiroshi SHIBATA)   

Target version:    

ruby -v: ruby 2.1.5p273 Backport: 2.1: UNKNOWN, 2.2: DONE, 2.3: DONE

Description

Float(arg) → float

Returns arg converted to a float. Numeric types are converted directly, the rest are converted using arg.to_f. Converting nil generates

a TypeError.

Strings are NOT converted using arg.to_f

'123_INVALID'.to_f 

# => 123.0

 
Float('123_INVALID') 

# => ArgumentError

 This could be fixed by changing object.c like so:

-       return DBL2NUM(rb_str_to_dbl(val, TRUE));

+       return DBL2NUM(rb_str_to_dbl(val, FALSE));

 But it appears that this is desired behavior as there are many specs to ensure this strict validity checking. Please update the

documentation to reflect this.

Thanks,

Brian

Related issues:

Related to Ruby - Bug #9574: Inconsistent behavior between Kernel#Float and to_f Closed

Associated revisions

Revision 3827c23af571895a76153c006a07136704c3d33e - 10/14/2016 09:27 AM - hsbt (Hiroshi SHIBATA)

object.c: Improve documentation for Integer conversion.

[ruby-core:71661][Bug #11736][ci skip]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56421 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3827c23a - 10/14/2016 09:27 AM - hsbt (Hiroshi SHIBATA)

object.c: Improve documentation for Integer conversion.

[ruby-core:71661][Bug #11736][ci skip]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@56421 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 331fea278b05d4ef32c271d000192288f505f494 - 10/27/2016 07:27 AM - U.Nakamura 

merge revision(s) 56421,56422: [Backport #11736]

    * object.c: Improve documentation for Integer conversion.

      [ruby-core:71661][Bug #11736][ci skip]

    * object.c: Improve documentation for Float conversion.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@56501 b2dd03c8-39d4-4d8f-98ff-823fe69b080e
Revision 331fea27 - 10/27/2016 07:27 AM - U.Nakamura 

merge revision(s) 56421,56422: [Backport #11736]

    * object.c: Improve documentation for Integer conversion.

      [ruby-core:71661][Bug #11736][ci skip]

    * object.c: Improve documentation for Float conversion.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_2@56501 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 627eec87257d22022d0c67fad697be8daaafef5a - 11/11/2016 04:06 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 56421,56422: [Backport #11736]

    * object.c: Improve documentation for Integer conversion.

      [ruby-core:71661][Bug #11736][ci skip]

    * object.c: Improve documentation for Float conversion.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56722 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 627eec87 - 11/11/2016 04:06 PM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 56421,56422: [Backport #11736]

    * object.c: Improve documentation for Integer conversion.

      [ruby-core:71661][Bug #11736][ci skip]

    * object.c: Improve documentation for Float conversion.

 git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/branches/ruby_2_3@56722 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 12/07/2015 07:43 AM - ko1 (Koichi Sasada)

- Description updated

- Assignee set to zzak (zzak _)

Document is wrong.

Zack, could you fix it?

#2 - 02/09/2016 05:52 PM - dpulliam (Dylan Pulliam)

- File 0001-Improve-documentation-on-Float-Arg.patch added

- ruby -v set to ruby 2.1.5p273

I have prepared a patch for this. Let me know what you think.

#3 - 10/14/2016 09:27 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Closed

Applied in changeset r56421.

object.c: Improve documentation for Integer conversion.

[ruby-core:71661][Bug #11736][ci skip]

#4 - 10/14/2016 09:29 AM - hsbt (Hiroshi SHIBATA)

- Assignee changed from zzak (zzak _) to hsbt (Hiroshi SHIBATA)

- Backport changed from 2.0.0: UNKNOWN, 2.1: UNKNOWN, 2.2: UNKNOWN to 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED

#5 - 10/27/2016 07:27 AM - usa (Usaku NAKAMURA)

- Backport changed from 2.1: UNKNOWN, 2.2: REQUIRED, 2.3: REQUIRED to 2.1: UNKNOWN, 2.2: DONE, 2.3: REQUIRED

ruby_2_2 r56501 merged revision(s) 56421,56422.
#6 - 11/11/2016 04:06 PM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.1: UNKNOWN, 2.2: DONE, 2.3: REQUIRED to 2.1: UNKNOWN, 2.2: DONE, 2.3: DONE

ruby_2_3 r56722 merged revision(s) 56421,56422.

#7 - 07/22/2019 03:58 AM - jeremyevans0 (Jeremy Evans)

- Related to Bug #9574: Inconsistent behavior between Kernel#Float and to_f added

Files

0001-Improve-documentation-on-Float-Arg.patch 1.25 KB 02/09/2016 dpulliam (Dylan Pulliam)
